#include "buttonnode.h"
#include "buttonshape.h"
#include "backgroundnode.h"

#include <iostream>

#include "scene/scenetree.h"
#include "input.h"
#include "sparrowshell/sparrowshell.h"
#include "mesh.h"
#include "phongmaterial.h"
#include "tools/font.h"
#include "resourcemanager.h"
#include "sparrowrenderer.h"

ButtonNode::ButtonNode(glm::vec2 position,ButtonShape* shape):
    m_position(position),m_shape(shape),i(0)
{
    addChild(m_shape->getBackGround());
}

MeshNode* ButtonNode::getBackGround()
{
    return m_shape->getBackGround();
}

void ButtonNode::update()
{
    Input* input = getEngine().getInput();
    sf::Vector2i v = input->getPosition();
    glm::vec2 pos = glm::vec2(v.x,v.y);

    if(m_label_updated){
        if(m_label_node)
            removeChild(m_label_node);
        Font* font = RESOURCE_GET(Font,"shellfont");
        std::wstring ws;
        ws.assign(m_label.begin(),m_label.end());
        m_label_node = font->getTextNode(ws,m_label_color,32);
        addChild(m_label_node);
        getEngine().getScene()->updateShaders();
        m_label_updated = false;
    }

    if(i == 120){
        glm::vec4 posa = m_transform[3];
        glm::vec4 posb = getBackGround()->getParentTransform()[3];
        glm::vec4 posc = m_label_node->getParentTransform()[3];
        std::cout << posa.x << " " << posa.y <<"\n"<< posb.x << " " << posb.y << "\n" << posc.x << " " << posc.y << "\n"<< std::endl;
        i=0;
    }
    i++;
    for (auto action : input->getActions())
    {
        if (action == m_action){
            if (m_shape->hover(m_position,pos))
                m_callback->exec();
        }
    }
}
